---------------------------------------------------------------
--                                                           
--  RAPID - Rapid Ada Portable Interface Designer     
--                                                           
--  AUTO_POSITION.ADB 
--  Description : Autogeneration widget positions in Dialog
--                       
--  By: Dmitri Anisimkov
--                                         
-- RAPID is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
with Tcl,Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;
package Auto_Position is

   type Dialog_Button_Proc is access procedure;

   type Positioner is private;

   procedure Start_New_Sequence(Pos : in out Positioner;
      Interp : in Tcl.Tcl_Interp;Window_Name : String);
   procedure Start_New_Column(Pos : in out Positioner);
   procedure Set_Auto_New_Column(Pos : in out Positioner; Row_Count : Integer);
   procedure Add_Entry(Pos : in out Positioner; Label, Name : String; Value : String := "");
   procedure Add_Entry(Pos : in out Positioner;Label,Name : String; Value : Integer);
   procedure Add_Message(Pos : in out Positioner; Text, Back_Color : String);
   procedure Add_Check_Button(Pos : in out Positioner; Text, Name : String;Value: boolean:=false);
   procedure Add_Apply_Ok_Cancel(Pos : in out Positioner;
      On_Apply : Dialog_Button_Proc;
      On_Ok : Dialog_Button_Proc := null;
      On_Cancel : Dialog_Button_Proc := null);

   generic
	type Enum is (<>);
   package Enumeration_Entry is

   function To_String(e : enum) return string;
   
   procedure Add_Entry(Pos : in out Positioner;
      Label,Name : String; Value : Enum := Enum'First);

   procedure Add_Entry(Pos : in out Positioner;
      Label,Name : String; Value : String);

   function Get_Enum_Entry(Interp : Tcl.Tcl_Interp;
      Window_Name : String; Name : String) return string;

   function Get_Enum_Entry(Interp : Tcl.Tcl_Interp;
      Window_Name : String; Name : String) return Enum;

   end Enumeration_Entry;

private

   type Positioner is record
      Interp : Tcl.Tcl_Interp;
      Col_Idx : Integer := 0;
      Row_Idx : Integer := 0;
      Col_Inc : Integer := 0;
      Max_Row : Integer := 0;
      Row_Auto_New_Column : Integer := 0;
      Window_Name : Unbounded_String;
   end record;

end Auto_Position;