with Main_Widgets;
with Tcl_Utilities;
with Main;
with Data;
with Data_Widgets;
with Common_Dialogs;

use Main_Widgets;


package body Sort is




   procedure Go is
   begin
      Data.Generate_Window(Main.Interp);
      Data_Widgets.Set_Button(Main.Interp,Data_Widgets.In_Order);
   end Go;

   procedure Sort_Em is
      Which_Sort : Main_Widgets.Sort_Type_Type;
      Which_Data : Data_Widgets.Data_Type_Type;
      Checked : Boolean;
      Data_Count : Integer range 2..100;
      type String_Ptr is access all String;
      Msg : String_Ptr;

   begin
      Which_Sort := Read_Group (Main.Interp);
      Which_Data := Data_Widgets.Read_Group (Main.Interp);

      Checked := Tcl_Utilities.Is_Checked (Main.Interp,"descending");
      begin
         Tcl_Utilities.Get_Text_Entry(Main.Interp,".data","count",Data_Count);
      exception
         when others => Data_Count := 100;
      end;
      Tcl_Utilities.Destroy_Window(Main.Interp,".data");
      if not Checked then
         Msg := new String'("Ascending");
      else
         Msg := new String'("Descending");
      end if;
      case Which_Sort is
         when Main_Widgets.Bubble => Common_Dialogs.Ok_Box("Bubble Sort"&Ascii.Lf&Msg.all&Ascii.Lf&
               Integer'Image(Data_Count)&Ascii.Lf&Data_Widgets.Data_Type_Type'Image(Which_Data),Main.Interp);
         when Main_Widgets.Shell => Common_Dialogs.Ok_Box("Shell Sort"&Ascii.Lf&Msg.all&Ascii.Lf&
               Integer'Image(Data_Count)&Ascii.Lf&Data_Widgets.Data_Type_Type'Image(Which_Data),Main.Interp);
         when Main_Widgets.Quick => Common_Dialogs.Ok_Box("Quick Sort"&Ascii.Lf&Msg.all&Ascii.Lf&
               Integer'Image(Data_Count)&Ascii.Lf&Data_Widgets.Data_Type_Type'Image(Which_Data),Main.Interp);

         when Main_Widgets.Insertion => Common_Dialogs.Ok_Box("Insertion Sort"&Ascii.Lf&Msg.all&Ascii.Lf&
               Integer'Image(Data_Count)&Ascii.Lf&Data_Widgets.Data_Type_Type'Image(Which_Data),Main.Interp);
         when None_Selected => null;
      end case;
   end Sort_Em;


   procedure Bubble_Asc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Bubble);
      Tcl_Utilities.Deselect_Box(Main.Interp,".","descending");
   end Bubble_Asc;

   procedure Shell_Asc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Shell);
      Tcl_Utilities.Deselect_Box(Main.Interp,".","descending");
   end Shell_Asc;


   procedure Quick_Asc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Quick);
      Tcl_Utilities.Deselect_Box(Main.Interp,".","descending");
   end Quick_Asc;


   procedure Insert_Asc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Insertion);
      Tcl_Utilities.Deselect_Box(Main.Interp,".","descending");
   end Insert_Asc;

   procedure Bubble_Desc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Bubble);
      Tcl_Utilities.Select_Box(Main.Interp,".","descending");
   end Bubble_Desc;


   procedure Shell_Desc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Shell);
      Tcl_Utilities.Select_Box(Main.Interp,".","descending");
   end Shell_Desc;

   procedure Quick_Desc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Quick);
      Tcl_Utilities.Select_Box(Main.Interp,".","descending");
   end Quick_Desc;

   procedure Insert_Desc is
   begin
      Main_Widgets.Set_Button(Main.Interp,Insertion);
      Tcl_Utilities.Select_Box(Main.Interp,".","descending");
   end Insert_Desc;

   procedure Quit is
   begin
      Common_Dialogs.Quit_Dialog(Main.Interp);
   end Quit;



end Sort;
