---------------------------------------------------------------
--                                                           
--  RAPID - Rapid Ada Portable Interface Designer
--                                                           
--  GUI-WIDGET-RADIO_BUTTON.ADS
--  Description : GUI Widget Radio Button 
--                       
--  By: Martin Carlisle and Patrick Maes
--                                         
-- RAPID is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
-- 02/14/99 Dmitri Anisimkov : Set_Property_Entries instead Set_Properties
-- for creation inheritable propery editors without designer
---------------------------------------------------------------
with Ada.Text_Io;
with Auto_Position;

package Gui.Widget.Radio_Button is
   type Radio_Button is new Gui.Widget.Gui_Widget with record
      Text           : String_Pointer;
      Group          : String_pointer;
   end record;

   -- reads information from file into GUI_Widget,
   -- assumes keyword already read.
   procedure Read_Widget(Widget : in out Radio_Button;
      File        : in Ada.Text_Io.File_Type);

   procedure Get_Widget_Params(Widget : in out Radio_Button;
      Params : in String);

   -- Writes information to file from GUI_Widget
   procedure Write_Widget(Widget : in Radio_Button;
      File : in Ada.Text_Io.File_Type);

   -- Generate Ada/Tcl code for this window.
   procedure Generate_Widget(Widget : in Radio_Button;
      Window_Name : in String;
      File : in Ada.Text_Io.File_Type;
      Tcl_Only : in Boolean);

   -- display the widget to a window
   procedure Display_Widget(Widget : in Radio_Button;
      Interp      : in Tcl.Tcl_Interp;
      Window_Name : in String);

   procedure Set_Property_Entries(Widget : in out Radio_Button;
      Pos : in out Auto_Position.Positioner);

   procedure Apply_Properties(Widget : in out Radio_Button);

   procedure Check_Properties(Widget : in out Radio_Button;
      Ok : out Boolean);

   function Properties_Dialog_Name(Widget : in Radio_Button) return String;

end Gui.Widget.Radio_Button;