---------------------------------------------------------------
--                                                           
--  RAPID - Rapid Ada Portable Interface Designer
--                                                           
--  GUI.ADS 
--  Description : Root of GUI Hierarchy
--                       
--  By: Martin Carlisle
--                                         
-- RAPID is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
-- Contains base types, but no objects
---------------------------------------------------------------
-- 03/16/99 Dmitri Anisimkov Add utilities for save/load 
--   properties
---------------------------------------------------------------
with Limits;
with Ada.Text_Io;
package gui is

   type String_Pointer is access all String;
   -- 
   subtype Word_Type is String(1..Limits.Max_Word_Length);

   function Get_Widget_Param(Params,Param_Name : String;
      Default : String := "") return String;

   function Get_Widget_Param(Params,Param_Name : String;
       Default : Integer := 0) return Integer;

   function Get_Widget_Param(Params,Param_Name : String;
       Default : Float := 0.0)
      return Float;

   function Get_Widget_Param(Params,Param_Name : String)
      return Boolean;

   procedure Put_Widget_Param(File  : in Ada.Text_Io.File_Type;
   Param_Name : String;Param_Value : Integer);

   procedure Put_Widget_Param(File  : in Ada.Text_Io.File_Type;
   Param_Name,Param_Value : String);

   procedure Put_Widget_Param(File  : in Ada.Text_Io.File_Type;
   Param_Name : String;Param_Value : Boolean);

   procedure Put_Widget_Param(File  : in Ada.Text_Io.File_Type;
   Param_Name : String;Param_Value : Float);

   generic
      type Num is delta <>;
      Default_Value : Num;
   package Fixed_Param_IO is
      function To_Numeric(Str : String) return Num;
      function To_String(Numeric : Num) return String;
      function Get_Widget_Param(Params,Param_Name : String) return Num;
      procedure Put_Widget_Param(File  : in Ada.Text_Io.File_Type;
         Param_Name : String;Param_Value : Num);
   end Fixed_Param_IO;

end gui;