---------------------------------------------------------------
--                                                           
--  RAPID - Rapid Ada Portable Interface Designer     
--                                                           
--  MENU_EDIT.ADS 
--  Description : Used to visually edit the menus
--                       
--  By: Martin Carlisle
--                                         
-- RAPID is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
-- These procedures happen when the user presses the menu 
-- edit button.  First called is edit, which creates the dialog
---------------------------------------------------------------

with Tcl;
with Gui.Menu;

package Menu_Edit is

   -- pops up a window that Edits the menu
   procedure Edit(Interp : Tcl.Tcl_Interp;
      Menubar : in Gui.Menu.Menu_Pointer;
      Window_Name : in String := ".");

   -- callbacks, each corresponding to a button
   -- on the menu edit window
   procedure Done_Edit;

   -- Edit_Item also pops up a dialog
   procedure Edit_Item;
   procedure Insert_Menu;
   procedure Insert_Choice;

   procedure Delete;
   
   -- callbacks corresponding to buttons for when a menu is
   -- inserted or edited.
   procedure Done_Insert_Dialog; -- also used for edit
   procedure Cancel_Insert_Dialog; -- also used for edit

   -- highlights a menu item when it is clicked
   procedure Highlight(Widget : in String; x,y : in Integer);

end Menu_Edit;