---------------------------------------------------------------
--                                                           
--  RAPID - Rapid Ada Portable Interface Designer     
--                                                           
--  MENU_GENERATE.ADS
--  Description : Generate Ada code for Menu to file
--                       
--  By: Martin Carlisle
--                                         
-- RAPID is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------

with Gui.Menu;
with Tcl;

package Menu_Generate is
   ---------------------------------------------------------------
   -- PROCEDURE Generate_Menu_Code
   --
   -- outputs the menu to an Ada file(s) of the specified name
   -- with .ads and .adb added.  If Tcl_Only is set, generates
   -- Tcl/Tk code directly without TASH binding.
   ---------------------------------------------------------------
   procedure Generate_Menu_Code(Menubar : in Gui.Menu.Menu_Pointer;
      Filename    : in String;
      Window_Name : in String := ".";
      Tcl_Only    : in Boolean := False);

   ---------------------------------------------------------------
   -- PROCEDURE Display_Menu_Code
   --
   -- outputs the menu to a window
   ---------------------------------------------------------------
   procedure Display_Menu_Code(Interp : Tcl.Tcl_Interp;
      Menubar : in Gui.Menu.Menu_Pointer;
      Window_Name : in String := ".";
      Redisplay : in Boolean := False);

   -- use me to get menubar_name so you can ask its height in gui-window   
   function Menubar_Name(Window_Name : in String) return String;

end Menu_Generate;