---------------------------------------------------------------
--                                                           
--  RAPID - Rapid Ada Portable Interface Designer     
--                                                           
--  SUBWINDOW_ACTIONS.ADS 
--  Description : Those actions from events in a subwindow
--                       
--  By: Martin Carlisle
--                                         
-- RAPID is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--
-- RAPID is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
with Gui.Widget;

package Subwindow_Actions is

   procedure Resize(Name : in String; Width : in Integer; Height : in Integer);

   procedure Add_Widget(startx : in Integer; starty : in Integer;
         endx : in Integer; endy : in Integer);

   procedure Duplicate(Widget : in Gui.Widget.Widget_Access);

   procedure Modify_Widget(Name : in String);

   procedure Select_Widget(Name : in String);

   procedure Move_Widget(Name : in String; startx : in Integer;
         starty : in Integer;
         endx : in Integer; endy : in Integer);

   procedure Resize_Widget(Handle : in String;
         Name : in String;
         startx : in integer; starty : in integer;
         endx   : in Integer; endy   : in Integer);

   procedure Resize_Window(
         startx : in integer; starty : in integer;
         endx   : in Integer; endy   : in Integer);

   procedure Done_Properties_Dialog;

   procedure Apply_Properties_Dialog;

   procedure Cancel_Properties_Dialog;

   procedure Edit_Menu;

end Subwindow_Actions;