---------------------------------------------------------------
--                                                           
--  TASH_FROM_GIF
--  Converts GIF files for use with TASH                   
--                       
--  By: Martin Carlisle
--                                         
-- TASH_FROM_GIF is free software; you can redistribute it and/or 
-- modify it without restriction.  However, we ask that you
-- please retain the original author information, and clearly  
-- indicate if it has been modified.
--
-- TASH_FROM_GIF is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
--
---------------------------------------------------------------
with Gif_To_Tash;
with Ada.Command_Line;
with Ada.Text_Io;

procedure Tash_From_Gif is
   procedure Usage is
   begin
      Ada.Text_Io.Put_Line("usage: " & Ada.Command_Line.Command_Name &
         " input_file (omit .gif)");
   end Usage;
begin
   if Ada.Command_Line.Argument_Count /= 1 then
      Usage;
      return;
   end if;

   Gif_To_Tash.Convert(Ada.Command_Line.Argument(1));
exception
   when Ada.Text_Io.Name_Error =>
      Ada.Text_Io.Put_Line("Invalid filename specified");
end Tash_From_Gif;